/* $Id: dexter-event-loop.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

#ifndef __DEXTER_EVENT_LOOP_H__
#define __DEXTER_EVENT_LOOP_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define DEXTER_TYPE_EVENT_LOOP             (dexter_event_loop_get_type ())
#define DEXTER_EVENT_LOOP(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), \
                                              DEXTER_TYPE_EVENT_LOOP, DexterEventLoop))
#define DEXTER_EVENT_LOOP_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), \
                                              DEXTER_TYPE_EVENT_LOOP, DexterEventLoopClass))
#define DEXTER_IS_EVENT_LOOP(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), \
                                              DEXTER_TYPE_EVENT_LOOP))
#define DEXTER_IS_EVENT_LOOP_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), \
                                              DEXTER_TYPE_EVENT_LOOP))
#define DEXTER_EVENT_LOOP_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), \
                                              DEXTER_TYPE_EVENT_LOOP, DexterEventLoopClass))

typedef struct _DexterEventLoop DexterEventLoop;
typedef struct _DexterEventLoopClass DexterEventLoopClass;

struct _DexterEventLoop
{
  GObject       parent;
  GMainContext *context;
  GMainLoop    *main_loop;
};

struct _DexterEventLoopClass
{
  GObjectClass parent_class;
};

GType     dexter_event_loop_get_type       (void) G_GNUC_INTERNAL G_GNUC_CONST;

void      dexter_event_loop_run            (DexterEventLoop *event_loop) G_GNUC_INTERNAL;

void      dexter_event_loop_quit           (DexterEventLoop *event_loop) G_GNUC_INTERNAL;

gboolean  dexter_event_loop_is_running     (DexterEventLoop *event_loop) G_GNUC_INTERNAL;

void      dexter_event_loop_source_attach  (DexterEventLoop *event_loop,
                                            GSource         *source) G_GNUC_INTERNAL;

G_END_DECLS

#endif /* __DEXTER_EVENT_LOOP_H__ */
