/* $Id: dexter-factory.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

#ifndef __DEXTER_FACTORY_H__
#define __DEXTER_FACTORY_H__

#include <glib-object.h>
#include <dexterplugin-service.h>

G_BEGIN_DECLS

typedef enum
{
  DEXTER_FACTORY_ERROR_MODULES_NOT_SUPPORTED,
  DEXTER_FACTORY_ERROR_NOT_ABSOLUTE_PATH,
  DEXTER_FACTORY_ERROR_FAILED
} DexterFactoryError;

#define DEXTER_FACTORY_ERROR dexter_factory_error_quark()
GQuark dexter_factory_error_quark (void) G_GNUC_INTERNAL;

#define DEXTER_TYPE_FACTORY             (dexter_factory_get_type ())
#define DEXTER_FACTORY(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), \
                                                  DEXTER_TYPE_FACTORY, DexterFactory))
#define DEXTER_FACTORY_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), \
                                                  DEXTER_TYPE_FACTORY, DexterFactoryClass))
#define DEXTER_IS_FACTORY(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), \
                                                  DEXTER_TYPE_FACTORY))
#define DEXTER_IS_FACTORY_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), \
                                                  DEXTER_TYPE_FACTORY))
#define DEXTER_FACTORY_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), \
                                                  DEXTER_TYPE_FACTORY, DexterFactoryClass))

typedef struct _DexterFactory DexterFactory;
typedef struct _DexterFactoryClass DexterFactoryClass;

GType                     dexter_factory_get_type     (void) G_GNUC_INTERNAL G_GNUC_CONST;

void                      dexter_factory_load_plugins (DexterFactory  *factory,
                                                       GError        **error) G_GNUC_INTERNAL;

DexterPluginServiceGroup *dexter_factory_get_services (DexterFactory  *factory,
                                                       GType           iface_type) G_GNUC_INTERNAL G_GNUC_MALLOC;

G_END_DECLS

#endif /* __DEXTER_FACTORY_H__ */
