/* $Id: dexter-log.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

#ifndef __DEXTER_LOG_H__
#define __DEXTER_LOG_H__

#include <glib.h>

G_BEGIN_DECLS

typedef enum
{
  DEXTER_LOG_CRIT,
  DEXTER_LOG_ERR,
  DEXTER_LOG_WARNING,
  DEXTER_LOG_NOTICE,
  DEXTER_LOG_INFO,
  DEXTER_LOG_DEBUG
} DexterLogLevel;

void        dexter_log_init      (void) G_GNUC_INTERNAL;

void        dexter_log_exit      (void) G_GNUC_INTERNAL;

void        dexter_log           (gint level, const gchar *format, ...) G_GNUC_INTERNAL;

G_END_DECLS

#endif /* __DEXTER_LOG_H__ */
