/* $Id: dexter-module.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

#ifndef __DEXTER_MODULE_H__
#define __DEXTER_MODULE_H__

#include <gmodule.h>
#include <glib-object.h>
#include <dexterplugin-service.h>

G_BEGIN_DECLS

#define DEXTER_TYPE_MODULE            (dexter_module_get_type ())
#define DEXTER_MODULE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), DEXTER_TYPE_MODULE, DexterModule))
#define DEXTER_MODULE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), DEXTER_TYPE_MODULE, DexterModuleClass))
#define DEXTER_IS_MODULE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEXTER_TYPE_MODULE))
#define DEXTER_IS_MODULE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEXTER_TYPE_MODULE))
#define DEXTER_MODULE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), DEXTER_TYPE_MODULE, DexterModuleClass))

typedef struct _DexterModule DexterModule;
typedef struct _DexterModuleClass DexterModuleClass;
typedef struct _DexterModulePrivate DexterModulePrivate;

struct _DexterModuleClass
{
  GTypeModuleClass parent_class;
};

struct _DexterModule 
{
  GTypeModule               parent;
  GModule                  *library;
                            /* required plugin symbols */
  void                      (*dexter_plugin_init)          (DexterModule *plugin_module);
  void                      (*dexter_plugin_exit)          (void);
  DexterPluginServiceGroup *(*dexter_plugin_get_services)  (void);
};

GType                     dexter_module_get_type     (void) G_GNUC_INTERNAL G_GNUC_CONST;

DexterModule             *dexter_module_new          (const gchar *filename) G_GNUC_INTERNAL G_GNUC_MALLOC;

DexterPluginServiceGroup *dexter_module_get_services (const DexterModule *module) G_GNUC_INTERNAL G_GNUC_MALLOC;

G_END_DECLS

#endif /* __DEXTER_MODULE_H__ */
