/* $Id: dexter-server-internal.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

#ifndef __DEXTER_SERVER_INTERNAL_H__
#define __DEXTER_SERVER_INTERNAL_H__

#include <glib-object.h>
#include <dexter-server.h>

G_BEGIN_DECLS

#define DEFAULT_SERVER_HOST                 "127.0.0.1"
#define DEFAULT_SERVER_SERVICE              "3663"
#define DEFAULT_SERVER_SOCKET_OPTIONS       NULL
#define DEFAULT_SERVER_MAX_BACKLOG          16
#define DEFAULT_SERVER_MAX_CLIENTS          5
#define DEFAULT_SERVER_RECV_BUFFER_SIZE     4096
#define DEFAULT_SERVER_TLS_SUPPORT_FLAG     DEXTER_SERVER_TLS_SUPPORT_NONE
#define DEFAULT_SERVER_TLS_CLIENT_CERT_FLAG DEXTER_SERVER_TLS_CLIENT_CERT_REQUESTED
#define DEFAULT_SERVER_TLS_CERT_FILE        "/etc/ssl/libdexter/server-cert.pem"
#define DEFAULT_SERVER_TLS_KEY_FILE         "/etc/ssl/libdexter/server-key.pem"
#define DEFAULT_SERVER_TLS_TRUST_FILE       "/etc/ssl/libdexter/server-trust.pem"
#define DEFAULT_SERVER_TLS_CRL_FILE         "/etc/ssl/libdexter/server-crl.pem"
#define DEFAULT_SERVER_TLS_VERIFY_HOSTNAME  FALSE


#define DEXTER_TYPE_SERVER              (dexter_server_get_type ())
#define DEXTER_SERVER(obj)              (G_TYPE_CHECK_INSTANCE_CAST((obj), \
                                            DEXTER_TYPE_SERVER, DexterServer))
#define DEXTER_SERVER_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), \
                                            DEXTER_TYPE_SERVER, DexterServerClass))
#define DEXTER_IS_SERVER(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), \
                                              DEXTER_TYPE_SERVER))
#define DEXTER_IS_SERVER_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), \
                                              DEXTER_TYPE_SERVER))
#define DEXTER_SERVER_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), \
                                            DEXTER_TYPE_SERVER, DexterServerClass))

typedef struct _DexterServerClass DexterServerClass;

GType     dexter_server_get_type     (void) G_GNUC_INTERNAL G_GNUC_CONST;

#ifdef HAVE_LIBWRAP
gboolean  dexter_server_hosts_access (int) G_GNUC_INTERNAL;
#endif

G_END_DECLS

#endif /* __DEXTER_SERVER_INTERNAL_H__ */
