/* $Id: dexter-version.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

#ifndef __DEXTER_VERSION_H__
#define __DEXTER_VERSION_H__

#include <glib.h>
#include <dexterplugin-iversion.h>

G_BEGIN_DECLS

#define DEXTER_TYPE_VERSION             (dexter_version_get_type ())
#define DEXTER_VERSION(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), \
                                            DEXTER_TYPE_VERSION, DexterVersion))
#define DEXTER_VERSION_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), \
                                            DEXTER_TYPE_VERSION, DexterVersionClass))
#define DEXTER_IS_VERSION(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), \
                                            DEXTER_TYPE_VERSION))
#define DEXTER_IS_VERSION_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), \
                                            DEXTER_TYPE_VERSION))
#define DEXTER_VERSION_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), \
                                            DEXTER_TYPE_VERSION, DexterVersionClass))

typedef struct _DexterVersion DexterVersion;
typedef struct _DexterVersionClass DexterVersionClass;


GType   dexter_version_get_type                 (void) G_GNUC_INTERNAL G_GNUC_CONST;

guint   dexter_version_get_version_major        (DexterPluginIVersion *iversion) G_GNUC_INTERNAL;

guint   dexter_version_get_version_minor        (DexterPluginIVersion *iversion) G_GNUC_INTERNAL;

guint   dexter_version_get_version_micro        (DexterPluginIVersion *iversion) G_GNUC_INTERNAL;

void    dexter_version_check_version_exact      (DexterPluginIVersion *iversion,
                                                 guint                 major, 
                                                 guint                 minor, 
                                                 guint                 micro) G_GNUC_INTERNAL;

void    dexter_version_check_version_compatible (DexterPluginIVersion *iversion,
                                                 guint                 major, 
                                                 guint                 minor, 
                                                 guint                 micro) G_GNUC_INTERNAL;

G_END_DECLS

#endif /* __DEXTER_VERSION_H__ */
