/* $Id: dexterplugin-imain.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

/**
 * SECTION:dexterplugin-imain
 * @title: DexterPluginIMain
 * @short_description: Interface of interfaces to Libdexter main library
 * @see_also:
 *
 * Plugins access available interfaces to the main Libdexter library
 * via this interface of interfaces.
 **/

#ifndef __DEXTERPLUGIN_IMAIN_H__
#define __DEXTERPLUGIN_IMAIN_H__

#include <glib.h>
#include <dexterplugin-iconfig.h>
#include <dexterplugin-iversion.h>

G_BEGIN_DECLS

typedef struct _DexterPluginIMain DexterPluginIMain;

/**
 * DexterPluginIMain:
 * @iconfig: configuration file interface.
 * @iversion: version information interface.
 *
 * Definition of the interface of interfaces to the main Libdexter library.
 **/
struct _DexterPluginIMain
{
  /*< public >*/
  DexterPluginIConfig     *iconfig;
  DexterPluginIVersion    *iversion;

  /*< private >*/
  void                    (*reserved3)            (void);
  void                    (*reserved4)            (void);
  void                    (*reserved5)            (void);
  void                    (*reserved6)            (void);
  void                    (*reserved7)            (void);
  void                    (*reserved8)            (void);
  void                    (*reserved9)            (void);
  void                    (*reserved10)           (void);
  void                    (*reserved11)           (void);
  void                    (*reserved12)           (void);
  void                    (*reserved13)           (void);
  void                    (*reserved14)           (void);
  void                    (*reserved15)           (void);
  void                    (*reserved16)           (void);
};

G_END_DECLS

#endif /* __DEXTERPLUGIN_IMAIN_H__ */
