/* $Id: dexterplugin-ithreadpool.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

#ifndef __DEXTERPLUGIN_ITHREADPOOL_H__
#define __DEXTERPLUGIN_ITHREADPOOL_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define DEXTERPLUGIN_TYPE_ITHREADPOOL               (dexterplugin_ithreadpool_get_type ())
#define DEXTERPLUGIN_ITHREADPOOL(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), \
                                                        DEXTERPLUGIN_TYPE_ITHREADPOOL, \
                                                        DexterPluginIThreadPool))
#define DEXTERPLUGIN_IS_ITHREADPOOL(obj)            (G_TYPE_CHECK_INSTANCE_TYPE ((obj), \
                                                        DEXTERPLUGIN_TYPE_ITHREADPOOL))
#define DEXTERPLUGIN_ITHREADPOOL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), \
                                                        DEXTERPLUGIN_TYPE_ITHREADPOOL, \
                                                        DexterPluginIThreadPoolInterface))

/*[no gtk-doc]*
 * DexterPluginIThreadPool:
 *
 * The thread pool interface.
 **/
typedef struct _DexterPluginIThreadPool DexterPluginIThreadPool;
typedef struct _DexterPluginIThreadPoolInterface DexterPluginIThreadPoolInterface;

/*[no gtk-doc]*
 * DexterPluginIThreadPoolInterface:
 * @push_task: See dexterplugin_ithreadpool_push_task().
 *
 * Definition of the thread pool interface.
 **/
struct _DexterPluginIThreadPoolInterface
{
  /*< private >*/
  GTypeInterface parent_interface;

  /*< public >*/

  /* virtual methods */

  gboolean  (*push_task)  (DexterPluginIThreadPool  *ithreadpool,
                           GThreadFunc               func,
                           gpointer                  data,
                           GError                  **error);

  /*< private >*/
  void      (*reserved1)  (void);
  void      (*reserved2)  (void);
  void      (*reserved3)  (void);
  void      (*reserved4)  (void);
  void      (*reserved5)  (void);
  void      (*reserved6)  (void);
  void      (*reserved7)  (void);
  void      (*reserved8)  (void);
};

GType       dexterplugin_ithreadpool_get_type   (void) G_GNUC_CONST;

gboolean    dexterplugin_ithreadpool_push_task  (DexterPluginIThreadPool  *ithreadpool,
                                                 GThreadFunc               func,
                                                 gpointer                  data,
                                                 GError                  **error);

G_END_DECLS

#endif /* __DEXTERPLUGIN_ITHREADPOOL_H__ */
