/* $Id: dexterplugin-main.c 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * libdexter - a plugin-based, distributed sampling library.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

/**
 * SECTION:dexterplugin-main
 * @title: DexterPluginMain
 * @short_description: API's related to DexterPluginIMain interface to Libdexter main library
 * @see_also:
 *
 * API's related to DexterPluginIMain interface to Libdexter main library.
 *
 **/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <dexterplugin-main.h>
#include <dexterplugin-alias.h>

static DexterPluginIMain  *dexterplugin_imain = 0;


/**
 * dexterplugin_main_imain_get:
 *
 * Fetches the main interface of interfaces.
 *
 * Returns: #DexterPluginIMain interface.
 **/
const DexterPluginIMain *
dexterplugin_main_imain_get (void)
{
  return dexterplugin_imain;
}


void 
dexterplugin_main_imain_set (DexterPluginIMain *imain)
{
  g_return_if_fail (imain != NULL);

  dexterplugin_imain = imain;
}

#define __DEXTERPLUGIN_MAIN_C__
#include <dexterplugin-aliasdef.c>
