/* $Id: dxt-null.h 393 2012-03-06 23:36:44Z pkovacs $ */
/*
 * dxt-null - libdexter sampling plugin that does nothing at all.
 * Copyright (C) 2006-2012 Philip Kovacs <pkovacs@users.sourceforge.net>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301  USA
 *
*/

#ifndef __DXT_NULL_H__
#define __DXT_NULL_H__

#include <gmodule.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define DXT_NULL_SERVICE_NAME  "Dexter Null Service"
#define DXT_NULL_SERVICE_BLURB "The Null Service does nothing"
#define DXT_NULL_SERVICE_UUID  "fff385b0-4e80-41e5-983e-fe1be625afa3"


#define DXT_TYPE_NULL             (dxt_null_get_type ())
#define DXT_NULL(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), DXT_TYPE_NULL, DxtNull))
#define DXT_NULL_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), DXT_TYPE_NULL, DxtNullClass))
#define DXT_IS_NULL(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DXT_TYPE_NULL))
#define DXT_IS_NULL_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), DXT_TYPE_NULL))
#define DXT_NULL_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), DXT_TYPE_NULL, DxtNullClass))

typedef struct _DxtNull DxtNull;
typedef struct _DxtNullClass DxtNullClass;

GType  dxt_null_get_type       (void) G_GNUC_INTERNAL G_GNUC_CONST;
void   dxt_null_register_type  (GTypeModule *module) G_GNUC_INTERNAL;

G_END_DECLS

#endif
